#!/bin/bash

# Include directive for ssh_config is not yet honored by zsh-ssh
# (as of 15/05/2025)
# Because of this, we will join files in a single configuration file for the
# time being.

destination_file=~/.ssh/config

# Checking for additional folder for bgworld hosts.
if [[ -d ~/.ssh/bgworld ]]; then
  # If found, the local folder sshconfig contents will be converted to a
  # "personal"  file.
  destination_file=~/.ssh/config_personal
  cat ~/.dotfiles/sshconfig/* >${destination_file}
  bash ~/.ssh/bgworld/hooks/update-config
else
  cat ~/.dotfiles/sshconfig/* >${destination_file}
fi
