# Theming
autoload -Uz compinit vcs_info
compinit
zstyle ':vcs_info:*' enable git svn
setopt prompt_subst
source $DOTFILES/zsh/themes/gentoo.zsh-theme

setopt correct #  Auto correct mistakes
setopt extendedglob # allows regexp with *
setopt nocaseglob # Case insensitive globbing
setopt rcexpandparam # array expansion with parameters
setopt nocheckjobs # No warn about running processes on exiting
setopt nobeep
setopt appendhistory
setopt histignorealldups
setopt autocd
setopt inc_append_history
setopt histignorespace # Ignore putting in history commands beginning with a space

zstyle ':completion:*' matcher-list 'm:{a-zA-Z}={A-Zaz}' # Case insensitive completion
zstyle ':completion:*' list-colors "${(s.:.)LS_COLORS}" # Color completion
zstyle ':completion:*' rehash true # automatically updates new paths
# Speed completion
zstyle ':completion:*' accept-exact '*(N)'
zstyle ':completion:*' use-cache on
zstyle ':completion:*' cache-path ~/.zsh/cache

# History
HISTFILE=~/.zhistory
HISTSIZE=10000
SAVEHIST=10000
WORDCHARS=${WORDCHARS//\/[&.;]}

# Color man pages
export LESS_TERMCAP_mb=$'\E[01;32m'
export LESS_TERMCAP_md=$'\E[01;32m'
export LESS_TERMCAP_me=$'\E[0m'
export LESS_TERMCAP_se=$'\E[0m'
export LESS_TERMCAP_so=$'\E[01;47;34m'
export LESS_TERMCAP_ue=$'\E[0m'
export LESS_TERMCAP_us=$'\E[01;36m'
export LESS=-R

if [ -e /usr/share/zsh-autosuggestions/zsh-autosuggestions.zsh ]; then 
  source /usr/share/zsh-autosuggestions/zsh-autosuggestions.zsh
fi
if [ -e /usr/share/zsh-syntax-highlighting/zsh-syntax-highlighting.zsh ]; then
  source /usr/share/zsh-syntax-highlighting/zsh-syntax-highlighting.zsh
fi
